#-*- coding:utf8-*-

import sys
import StringIO
import traceback

from os.path import splitext, normcase, split
from os import walk
from PyQt4 import QtCore, QtGui
from copy import deepcopy

from main_window import Ui_MainWindow
from converter import convert

class main_ui(QtGui.QDialog, Ui_MainWindow):

    def __init__(self, parent=None):
        QtGui.QDialog.__init__(self)
        self.setupUi(self)

        self.encoder = QtCore.QTextCodec.codecForLocale()


        self.pushButton_add_file.clicked.connect(self.get_file_path)
        self.pushButton_quit.clicked.connect(self.quit)
        self.pushButton_add_directory.clicked.connect(self.add_directory)
        self.pushButton_chose_destination_directory.clicked.connect(self.set_destination_directory)
        self.pushButton_start_conversion.clicked.connect(self.do_conversion)
        self.pushButton_delete_all.clicked.connect(self.delete_all)
        self.pushButton_delete_selected.clicked.connect(self.delete_selected)

    def get_file_path(self):
        path = QtGui.QFileDialog.getOpenFileNames(parent=self, filter="*.stmp")

        for test in path:
            self.listWidget_added_files.addItem(test)

    def add_directory(self):
        path = unicode(self.get_directory_path())

        #print type(path)

        for (root, dirs, files) in walk(path):
            for file_path in files:
                if splitext(file_path)[1] == '.stmp':
                    self.listWidget_added_files.addItem(normcase(root+'/' + file_path))

    def set_destination_directory(self):
        path = self.get_directory_path()
        self.line_destination_directory.setText(path)

    def get_directory_path(self):
        return QtGui.QFileDialog.getExistingDirectory(parent=self)

    def do_conversion(self):
        #print(repr(self.line_destination_directory.text()))

        try:

            for index in xrange(self.listWidget_added_files.count()):
                source_path = str(self.encoder.fromUnicode(self.listWidget_added_files.item(index).text()))

                if self.line_destination_directory.text() == '':
                    destination_path = splitext(source_path)[0] + '.csv'

                else:
                    dest_directory = str(self.encoder.fromUnicode(self.line_destination_directory.text()))
                    destination_path = normcase(dest_directory + '/' +
                                                splitext(split(source_path)[1])[0] +
                                                '.csv')

                #print source_path, destination_path
                #print type(source_path), type(destination_path)

                convert(source_path, destination_path,
                        self.checkBox_summarize_places.isChecked())

        except :

            exception_string = StringIO.StringIO()
            traceback.print_exc(file=exception_string)

            message = QtGui.QMessageBox()
            message.setText("Konvertieren der datei %s fehlgeschlagen. Breche ab." % source_path.decode('utf8'))
            message.setIcon(QtGui.QMessageBox.Critical)
            message.setWindowTitle('Fehler!!!')
            message.setDetailedText(exception_string.getvalue())

            message.exec_()

        else:
            QtGui.QMessageBox.information(self, "Abgeschlossen", "Konvertieren Abgeschlossen")



        self.listWidget_added_files.clear()



    def delete_all(self):
        self.listWidget_added_files.clear()

    def delete_selected(self):
        selected = self.listWidget_added_files.selectedItems()
        all_items = self.get_item_list(self.listWidget_added_files)

        new_items = []
        for item in all_items:
            if item not in selected:
                new_items.append(str(item.text()))

        self.listWidget_added_files.clear()
        for item in new_items:
            self.listWidget_added_files.addItem(item)


    def get_item_list(self, list_widget):
        items = []

        for index in xrange(list_widget.count()):
            items.append(self.listWidget_added_files.item(index))

        return items

    def quit(self):
        self.close()


def main():

    app = QtGui.QApplication(sys.argv)

    main_window = main_ui()
    main_window.show()

    app.exec_()

if __name__ == "__main__":
    main()
